<template>
  <form @submit.prevent="onSubmit" class="needs-validation" novalidate>
    <section class="row mb-4 mb-lg-5 gy-3">
      <div class="col-12">
        <label for="address" class="form-label title-error"
          >Адрес вашей страницы</label
        >
        <input
          type="text"
          class="form-control"
          id="address"
          placeholder="https://"
          :value="formState.address"
          @input="onChangeAddress"
          :class="addressClasses"
          ref="addressRef"
        />
        <div class="invalid-feedback">Введите корректный адрес</div>
      </div>

      <div class="col-4">
        <label for="domain" class="form-label">Домен короткой ссылки</label>

        <select
          class="form-select"
          v-model="formState.domain"
          disabled
          id="domain"
        >
          <option value="link.cc">link.cc</option>
        </select>
      </div>

      <div class="row justify-content-between gy-3">
        <div class="col-3">
          <label for="source" class="form-label">UTM-source</label>
          <input
            type="text"
            class="form-control"
            id="source"
            v-model="formState.params.utm_source"
          />
        </div>
        <div class="col-3">
          <label for="medium" class="form-label">UTM-medium</label>
          <input
            type="text"
            class="form-control"
            id="medium"
            v-model="formState.params.utm_medium"
          />
        </div>
        <div class="col-3">
          <label for="campaign" class="form-label">UTM-campaign</label>
          <input
            type="text"
            class="form-control"
            id="campaign"
            v-model="formState.params.utm_campaign"
          />
        </div>
        <div class="col-3">
          <label for="content" class="form-label">UTM-content</label>
          <input
            type="text"
            class="form-control"
            id="content"
            v-model="formState.params.utm_content"
            required
          />
        </div>
      </div>
      <div class="row justify-content-between gy-3">
        <div class="col-3">
          <label for="term" class="form-label">UTM-term</label>
          <input
            type="text"
            class="form-control"
            id="term"
            v-model="formState.params.utm_term"
          />
        </div>
        <div class="col-12">
          <label for="comment" class="form-label"
            >Произвольный комментарий</label
          >
          <input
            type="text"
            class="form-control"
            id="comment"
            maxLength="100"
            v-model="formState.comment"
          />
        </div>
        <div class="col-12">
          <label for="result" class="form-label">Результат</label>
          <input
            type="text"
            class="form-control"
            id="result"
            :value="redirectUrl"
            readonly
            disabled
          />
        </div>
      </div>
    </section>

    <Button
      type="submit"
      :disabled="isSuccessSubmitted || isLoading"
      :loading="isLoading"
      :delay="250"
      class="me-4"
      >Добавить</Button
    >
    <Button @click="onFormReset">Отменить</Button>
  </form>
</template>

<script setup>
import { computed, reactive, ref } from "vue";
import Button from "../../../components/Button.vue";
import { createUrlLink } from "@/modules/Tracker/utils";
import { useLoading } from "@/composables";
import { useLinkStore } from "@/modules/Tracker/stores";
import { isURLValid } from "@/modules/Tracker/utils";

const getInitialState = () => ({
  address: "https://",
  domain: "link.cc",
  comment: "",
  params: {
    utm_source: "",
    utm_medium: "",
    utm_campaign: "",
    utm_content: "",
    utm_term: "",
  },
});

const formState = reactive(getInitialState());
const store = useLinkStore();
const { createNewLink } = store;
const { isLoading, setLoading } = useLoading();
const isSuccessSubmitted = ref(false);
const addressRef = ref(null);
const isAddressValid = ref(true);
const addressClasses = computed(() => {
  return {
    "is-invalid": !isAddressValid.value,
  };
});

const addressValidate = () => {
  return isURLValid(formState.address);
};

const onAddressFocus = () => {
  addressRef.value?.focus();
};

const redirectUrl = computed(() => {
  try {
    const filteredFormValues = Object.keys(formState.params).reduce(
      (acc, key) => {
        if (formState.params[key]) {
          acc[key] = formState.params[key];
        }
        return acc;
      },
      {}
    );

    return createUrlLink(formState.address, filteredFormValues);
  } catch (e) {
    return "";
  }
});
const onChangeAddress = (event) => {
  const { value } = event.target;
  formState.address = value;
  if (!isAddressValid.value && addressValidate()) {
    isAddressValid.value = true;
  }
};

const onFormReset = () => {
  Object.assign(formState, getInitialState());
  isAddressValid.value = true;
};

const onSubmit = async () => {
  if (!addressValidate()) {
    onAddressFocus();
    isAddressValid.value = false;
    return;
  }
  isAddressValid.value = true;
  const { comment, domain } = formState;
  const body = {
    comment,
    domain,
    redirectUrl: redirectUrl.value.href,
  };

  setLoading(true);
  try {
    const result = await createNewLink(body);
    if (result.ok) {
      isSuccessSubmitted.value = true;
      // onFormReset();
    }
  } catch (e) {
    return Promise.reject(e);
  } finally {
    setLoading(false);
  }
};
</script>
